describe("Site Admin Functionality", () => {
  beforeEach(() => {
    cy
      .visit("/")
      .get("[data-testid='banner-login-button']")
      .click()
      .get("input[name='username']")
      .type("site_admin")
      .get("input[name='password']")
      .type("SiteAdminPassword1!")
      .get("[data-testid='login-dialog-login-button']")
      .click()
      .url()
      .should("contain", "/search")
  });

  it("allows the site admin to create a new animal", () => {
    cy
      .get("[data-testid='navbar-hamburger-menu']")
      .click()
      .get("[data-testid='nav-drawer-add-animal']")
      .click()
      .get("[data-testid='name-field']")
      .type("New Animal")
      .get("[data-testid='description-field']")
      .type("New Animal Description")
      .get("[data-testid='dateOfBirth-field']")
      .type("2020-03-24")
      .get("[data-testid='breed-field']")
      .type("Terrier")
      .get("[aria-labelledby='gender']")
      .click()
      .get("[data-value='Male']")
      .click()
      .get("[aria-labelledby='status']")
      .click()
      .get("[data-value='Available']")
      .click()
      .get("[aria-labelledby='kind']")
      .click()
      .get("[data-value='Dog']")
      .click()
      .get(".react-select__placeholder")
      .click()
      .get(".react-select__option")
      .first()
      .click()
      .get("[data-testid='add-animal-submit-button']")
      .click()
      .wait(4000)
      .get("[data-testid='animal-card-name']")
      .first()
      .should("contain", "New Animal")
      .get("[data-testid='animal-card-sex-breed']")
      .first()
      .should("contain", "Male, Terrier")
      .get("[data-testid='animal-card-description']")
      .first()
      .should("contain", "New Animal Description")
  });

  it("allows the site admin to update an animal", () => {
    cy
      .get("[data-testid='animal-card-view']")
      .first()
      .click()
      .get("[data-testid='animal-profile-edit-icon']")
      .click()
      .get("[data-testid='name-field']")
      .clear()
      .type("Updated Animal")
      .get("[data-testid='animal-edit-update-button']")
      .click()
      .get("[data-testid='animal-profile-name']")
      .should("contain", "Updated Animal")
  });

  it("allows the site admin to delete an animal", () => {
    cy
      .get("[data-testid='animal-card-view']")
      .first()
      .click()
      .get("[data-testid='delete-icon']")
      .click()
      .wait(1000)
      .get("[data-testid='animal-card-name']")
      .first()
      .should("contain", "Meatball")
  });
});